package com.mrl.pixiv.buildsrc

import org.gradle.api.artifacts.Dependency
import org.gradle.api.artifacts.dsl.DependencyHandler
import org.gradle.kotlin.dsl.add

/**
 * Adds a dependency to the 'implementation' configuration.
 *
 * @param dependencyNotation notation for the dependency to be added.
 * @return The dependency.
 *
 * @see [DependencyHandler.add]
 */
fun DependencyHandler.`implementation`(dependencyNotation: Any): Dependency? =
    add("implementation", dependencyNotation)

// androidTestImplementation
fun DependencyHandler.`androidTestImplementation`(dependencyNotation: Any): Dependency? =
    add("androidTestImplementation", dependencyNotation)

// testImplementation
fun DependencyHandler.`testImplementation`(dependencyNotation: Any): Dependency? =
    add("testImplementation", dependencyNotation)

// coreLibraryDesugaring
fun DependencyHandler.`coreLibraryDesugaring`(dependencyNotation: Any): Dependency? =
    add("coreLibraryDesugaring", dependencyNotation)

// ksp
fun DependencyHandler.`ksp`(dependencyNotation: Any): Dependency? =
    add("ksp", dependencyNotation)